<template>
  <q-checkbox
    class="col-6 q-mb-md"
    v-model="additionalInsurance"
    :label="t('additionalIssuarance')"
  />

  <q-select
    v-show="additionalInsurance"
    v-model="selectedAdditionalInsurance"
    :label="t('typeOfadditionalIssuarance')"
    :options="possibleShortTimeAditionalInsuranceOptions"
    map-options
    emit-value
    dense
    dropdown-icon="expand_more"
    outlined
  />

  <p class="text-center q-pa-md text-h6" v-if="isSummaryVisible">
    {{ t('finalIssurancePriceIs') }} : {{ summary?.toLocaleString() }} €
  </p>
</template>

<script setup lang="ts">
import { computed, defineEmits, defineProps, ref, withDefaults } from 'vue';
import { config } from 'src/utils/insurence-contansts';
import { useI18n } from 'vue-i18n';
const { t } = useI18n();

type Props = {
  summary: number | null | string;
  additionalInsurance: boolean;
  selectedAdditionalInsurance: number | null;
  selectedInsuranceType: string | null;
  isSummaryVisible: boolean;
};

const props = withDefaults(defineProps<Props>(), {
  summary: 0,
  additionalInsurance: false,
  selectedInsuranceType: null,
  selectedAdditionalInsurance: null,
  isSummaryVisible: false,
});
interface Emits {
  (e: 'update:summary', value: string): void;
  (e: 'update:additionalInsurance', value: boolean): void;
  (e: 'update:selectedAdditionalInsurance', value: string): void;
}
const emit = defineEmits<Emits>();

const summary = computed({
  get() {
    return props.summary;
  },
  set(summary: summary) {
    emit('update:summary', summary);
  },
});
const additionalInsurance = computed({
  get() {
    return props.additionalInsurance;
  },
  set(additionalInsurance: additionalInsurance) {
    emit('update:additionalInsurance', additionalInsurance);
  },
});

const selectedAdditionalInsurance = computed({
  get() {
    return props.selectedAdditionalInsurance;
  },
  set(selectedAdditionalInsurance: selectedAdditionalInsurance) {
    emit('update:selectedAdditionalInsurance', selectedAdditionalInsurance);
  },
});

const possibleShortTimeAditionalInsuranceOptions = computed(() => {
  return [
    {
      label: t('optionExtraInsurance.refund'),
      value:
        props.selectedInsuranceType ===
        t('possibleInsuranceTypeOptions.shortTime')
          ? config.extraShorTimeIsurance.refund
          : config.extraLongTimeIsurance.refund,
    },
    {
      label: t('optionExtraInsurance.sport'),
      value:
        props.selectedInsuranceType ===
        t('possibleInsuranceTypeOptions.shortTime')
          ? config.extraShorTimeIsurance.sport
          : config.extraLongTimeIsurance.sport,
    },
  ];
});
</script>
